CON
  _clkmode = xtal1 + pll16x      ' Crystal feedback & PLL multiplier
  _xinfreq = 5_000_000

con

Rpin = 17
Txpin = 16
baudR = 19_200
byteCount = 12
startByte = $A0 'Start
stopByte =  $0D 'And Stop Byte

OBJ
  pst:  "Parallax Serial Terminal"    'Call to pst object to utilize functions in the pst library.
  fds: "FullDuplexSerial"
  ser: "Simple_Serial"  

var

long rfidtag
''Vars abtaining to the tag ID
  BYTE tempBool[8]  'Temp boolean input 
  BYTE tagID[16]    'ID of RFID tag (Including stop and start bytes
  BYTE newID        'Set to 1 when there's a new value in tagID, 2 when there's an error

  ''Other vars
  BYTE bitsPerByte  'Bits per byte.  4 bits with starting byte, otherwise 8 bits
  BYTE currentBit   'What bit # are we receiving?
  BYTE currentByte  'What byte # are we receiving?
  BYTE byteBuilder  'Used to build up bits to a byte

pub go : success
  pst.Start(115_200)  
'rec pin 17
'tx pin 16
'19200 baud rate

 'dira[Rpin]~
 'outa[Rpin]~
 
 'dira[Txpin]~~
 'ina[Txpin]~

    'ser.init(Rpin, Txpin, baudR)
    fds.start(Rpin, Txpin, 0,baudR)
   

    pst.Str(String("Program Start "))
    
 
     'Watch P27 for incoming data
     IF INA[Txpin] > 0
        pause(5_000)  
       'ser.tx($FC)
       fds.tx($FC) 'led
       pause(5_000)
       'ser.tx($F8)
       fds.tx($F8) 'transmitter on
       pause(5_000)   
       'ser.tx($FA)
       fds.tx($FA)  'auto scan
       pause(5_000)
      success := rfidRead 'Start taking input from RFID tags

     repeat  100
      pst.Dec(tagID[currentbyte++])
    'rfidRead
    pst.Str(String("End "))
    pst.Chars(pst#NL, 1)   

  
   

   
PUB rfidRead : readSuccess   'Take data from P27
 ' pst.Str(String("1"))  
  'ser.rx
  fds.rx
 ' pst.dec(fds.rx) 
  bitsPerByte := 4 'Start byte has 4 bits
  currentByte := 0 'We're on the first byte
  REPEAT byteCount 'Loop 12 times
    currentBit := 1'We're on the first bit
    byteBuilder := 0  'Reset the bits stored on the byteBuilder
    REPEAT bitsPerByte 'Repeat once for every bit in current byte
      IF INA[17] > 0   'Is the incoming bit on or off?
        byteBuilder += 1 << (8 - currentBit) 'Add the value of the incoming byte to byteBuilder
      currentBit++ 'Done with this bit
      waitcnt(clkfreq/2400 + cnt) 'We have to wait until next bit comes
    tagID[currentByte] := byteBuilder 'We built the byte, lets move it to the tagID
    'pst.hex(tagID[currentByte] , 1)
    bitsPerByte := 8   'After the first byte, we need 8 bits per byte
    currentByte++      'We're done with this byte
  IF tagID[0] == startByte & tagID[11] == stopByte 'Are the start and stop bytes correct?
    readSuccess := 0  'YES!
  ELSE
    readSuccess := -1 'No

  pst.Str(String("finished rfidread "))  



   
pri Pause(duration)

  'This function pauses program execution for approximately [duration] micro seconds
  'so 1_000_000 would be approximately one second.  Doesnt account for instruction
  'execution time overhead.
  
  if duration < 500
   duration := 500          'lower bound limit. anything lower than this, we
                                'have to wait until the counter comes back around,
                                'which is MUCH longer than [duration].
  waitcnt(((clkfreq / 1_000_000) * duration) + cnt)


   
 

 
 

        